<?php
namespace PME\Modules\Planejamento\Prato;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DataSource\DataSet;


class QtdPessoaController extends \PME\Services\TeknisaCrud {
	protected $crudService;
	protected $parameterBag;
    protected $Lista;
    protected $utilities;
    protected $connection;
    protected $receitaController;
    protected $custoPlanejadoRealizado;

    public function __construct($crudService, $parameterBag, $entityManager, $Lista, $utilities, $connection, $receitaController, $custoPlanejadoRealizado) {
        $this->entityManager = $entityManager;
        $this->Lista = $Lista;
        $this->utilities = $utilities;
        $this->connection = $connection;
        $this->receitaController = $receitaController;
        $this->custoPlanejadoRealizado = $custoPlanejadoRealizado;
        parent::__construct($crudService, $parameterBag);
    }
  
    public function procedureQtdPessoa(DTO\Request $request, DTO\Response $response) {
        try {
            $nrorg = $this->utilities->getNrOrg();
            $rows = $request->getRow();
            $rows['NRORG'] = $nrorg;
            
            $cdprodIni = $rows['PRATO_INICIAL'] ? $rows['PRATO_INICIAL'] : 0;
            $cdprodFin = $rows['PRATO_FINAL'] ? $rows['PRATO_FINAL'].'z' : 'zzzzzzzzzz';
            
            $rowsReceita = $rows['IDTIPORECEITA'];
            
            $tipoReceita = 'PLST';    
            if (!(in_array('P', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 0, 1);
            if (!(in_array('L', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 1, 1);
            if (!(in_array('S', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 2, 1);
            if (!(in_array('T', $rowsReceita))) $tipoReceita = substr_replace($tipoReceita, 'X', 3, 1);
    
            $nrlista = '';
            $nrlistatp = '';
            $a = false;
            
            if (in_array('S', $rowsReceita)) {
                if(count($rows['SERVICO']) > 0) {
                    $servico = $rows['SERVICO'];
                } else {
                    // $servico = $this->getServicos($rows);
                    // $servico = $this->retornaServicosInd($rows);
                    $rowNew = array(
                      'CDFILIAL' => join("_", $rows['UNIDADE']),
                      'CDGRUPSERV' => $rows['GRUPOSERVICO'] ? $rows['GRUPOSERVICO'] : 'T',
                      'CDGRUPFILI' => $rows['GRUPFILI']['CDGRUPFILI'] ? $rows['GRUPFILI']['CDGRUPFILI'] : 'T',
                      'CDFILCENTPME' => $rows['CDFILCENTPME'],
                      'IDTIPOSERV' => '',
                    );
         
                    $requestNew = new DTO\Request\Row($rowNew,'', '', '');
                    $this->retornaServicosInd($requestNew, $response);
  
                    if (count($response->getDataSets()) > 0)
                        $servico = $response->getDataSets()[0]->getRows();
                    else $servico = array();
                }
                
                $rows['SERVICO'] = $servico;
                
                $unidadeServico = '';
                foreach($servico as $servfili) {
                  $unidadeServico .= $servfili['FILISERV'] . "_";
                }
                
                $nrlista = $this->Lista->geraLista($unidadeServico, $nrorg);
              }
            else {
                if (in_array('L', $rowsReceita)) {
                  if(count($rows['UNIDADE']) > 0) { 
                    $unidade = $rows['UNIDADE'];
                    $unidadeConcat = '';
                    foreach($unidade as $fil) {
                      $unidadeConcat .= $fil . "_";
                    }
                  } else {
                    // $unidade = $this->getAgregadaCentralPAE($rows);
                    $unidade = $this->getUnidade($rows);
                  
                    $unidadeConcat = '';
                    foreach($unidade as $fil) {
                      $unidadeConcat .= $fil['CDFILIAL'] . "_";
                    }
                  }
                  
                  $nrlista = $this->Lista->geraLista($unidadeConcat, $nrorg);
                }
        
                if (in_array('T', $rowsReceita) and !$nrlista) {
                  if(count($rows['UNIDADE']) > 0) {
                    $unidade = array();
                    foreach ($rows['UNIDADE'] as $cd) {
                      $unidade[] = array("CDFILIAL" => $cd);
                    }
                  } else {
                    $unidade = $this->getAgregadaCentralPAE($rows);      
                  }
                  
                  $unidadeConcat = '';
                  foreach($unidade as $filiTp) {
                    $unidadeConcat .= $filiTp['CDFILIAL'] . "_";
                  }
                
                  $nrlista = $this->Lista->geraLista($unidadeConcat, $nrorg);
                }
              }
              
            if (in_array('T', $rowsReceita)) $a = true;
            //}
        
            if ($a) {
              $tpCard = '';
              if(count($rows['TPCARD']) > 0) { 
                $tpCard = $rows['TPCARD']; 
              } else {
                $tpCard = $this->getTipoCard($rows); 
              }
              
              $tpCardConcat = '';
              foreach($tpCard as $row) {
                $tpCardConcat .= $row['CDTIPOCARD'] . "_";
              }
              $nrlistatp = $this->Lista->geraLista($tpCardConcat, $nrorg); 
            }
        
            $rowsRadio = $rows['ORDENA'];
            if ($rowsRadio === "1") $vrqtdepessoa = null;
            if ($rowsRadio === "0") $vrqtdepessoa = $rows['VRQTDEPESSOA'];

            $procedureCons = new StoredProcedure($this->connection, 'CALCULA_QTDE_PESSOA');
        
            $procedureCons->addParam(new Param('P_NRLISTA',          Param::PARAM_INPUT, $nrlista,                  Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_CDOPERADOR',       Param::PARAM_INPUT, $rows['CDOPERADOR'],       Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_CDPRATOINI',       Param::PARAM_INPUT, $cdprodIni,                Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_CDPRATOFIM',       Param::PARAM_INPUT, $cdprodFin,                Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_IDTIPOEXPORTACAO', Param::PARAM_INPUT, $rows['IDTIPOEXPORTACAO'], Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_IDTIPORECEITA',    Param::PARAM_INPUT, $tipoReceita,              Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_VRQTDEPESSOA',     Param::PARAM_INPUT, $vrqtdepessoa,             Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_CDFILCENTPME',     Param::PARAM_INPUT, $rows['CDFILCENTPME'],     Param::PARAM_TYPE_STR));
            $procedureCons->addParam(new Param('P_NRLISTATP',        Param::PARAM_INPUT, $nrlistatp,                Param::PARAM_TYPE_STR));
         
            $procedureCons->execute();
            return $procedureCons;
        } catch (\Exception $e) {
	        $response->setError(new Error($e->getMessage(), 500)); 
		}
    }
  
    /* public function getServicos($rows) {
        $dataSourceName = 'servicoAgrupGrupoUnidadeInd';
        
        if (empty($rows['UNIDADE'])) $cdfilial = 'T';
        else {
          $unidadeRow = [];
          $cdfilial = join("_", $rows['UNIDADE']);
        }
        
        if ($rows['GRUPOSERVICO'] == null) $grupServ = 'T';
        else $grupServ = $rows['GRUPOSERVICO']['CDGRUPSERV'];
        
        if ($rows['GRUPFILI'] == null) $grupFili = 'T';
        else $grupFili = $rows['GRUPFILI']['CDGRUPFILI'];
        
        $conditions = array(
            array(
                'columnName' => 'CDFILIAL',
                'operator' => '=',
                'value' => $cdfilial
            ),
            array(
                'columnName' => 'CDGRUPSERV',
                'operator' => '=',
                'value' => $grupServ
            ),
            array(
                'columnName' => 'CDGRUPFILI',
                'operator' => '=',
                'value' => $grupFili
            ),
            array(
                'columnName' => 'IDTIPOSERV',
                'operator' => '=',
                'value' => $rows['IDTIPOSERV']
            )
        );
        
        $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
        return $result;
    }*/
    
    public function getTipoCard($rows){
        $nrorg = $this->utilities->getNrOrg();
        $dataSourceName = 'tpCardapioPorCentralAtivo';
        
        $conditions = array(       
            array(
                'columnName' => 'IDTPCARDATIV',
                'operator' => '=',
                'value' => 'S'
            ),
            array(
                'columnName' => 'CDFILCENTPME',
                'operator' => '=',
                'value' =>  $rows['CDFILCENTPME']
            ),
            array(
                'columnName' => 'NRPASTATCARD',
                'operator' => '=',
                'value' => null
            ),
            array(
                'columnName' => 'NRORG',
                'operator' => '=',
                'value' => $nrorg
            )
        );
        
        $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
        return $result;
    }
  
    public function getAgregadaCentralPAE($rows){
        // $dataSourceName = 'agregadaPorCentral';
        $dataSourceName = 'agregadaPorCentralAgrup';
        
        $conditions = array(
            array(
                'columnName' => 'CDFILCENTPME',
                'operator' => '=',
                'value' => $rows['CDFILCENTPME']
            ),
             array(
                'columnName' => 'CDGRUPFILI',
                'operator' => '=',
                'value' => $rows['GRUPFILI']["CDGRUPFILI"]
            )
        );
        $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
        return $result;
    }
    
    private function getUnidade($rows){
        $dataSourceName = 'unidadePorAgrup';
        
        $conditions = array(
            array(
                'columnName' => 'P_CDGRUPFILI',
                'operator' => '=',
                'value' => $rows['GRUPFILI']["CDGRUPFILI"]
            )
        );
    
        $result = $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
        return $result;
    }
  
    public function alteracaoProporcional(DTO\Request\Row $request, DTO\Response $response) {
        $parameters = $request->getParameters();
        $row = $parameters['newRow'];
        $nrorg = $this->utilities->getNrOrg();
        
        $cdfilcentpme = $row['CDFILCENTPME'];
        $cdprato = $row['CDPRATO'];
        $cdFilAuxPrat = $row['CDFILAUXPRAT'];
        $produto = $row['CDPRODUTO'];
        $sgUnidadePrato = $row['SGUNIDADE'] ?? '';
        $tipoReceita = $row['TIPORECEITA'];
        $is_adjust_person_qt = $row['IS_ADJUST_PERSON_QT'] ?? false;
        isset($row['TPOPERACAO']) ? $tpOperacao = $row['TPOPERACAO'] : $tpOperacao = 'M'; 
        isset($row['PERCENTUAL']) ? $percentual = $row['PERCENTUAL'] : $percentual = '';
        isset($row['QTATIVA']) ? $qtAtiva = $row['QTATIVA'] : $qtAtiva = '';

        if(isset($row['CDSERVFILI'])) $row['CDSERVFILI'] == '' ? $row['CDSERVFILI'] = null : $row['CDSERVFILI'] = $row['CDSERVFILI'];
        if(isset($row['CDFILIAL'])) $row['CDFILIAL'] == '' ? $row['CDFILIAL'] = null : $row['CDFILIAL'] = $row['CDFILIAL'];
        if(isset($row['CDTIPOCARD'])) $row['CDTIPOCARD'] == '' ? $row['CDTIPOCARD'] = null : $row['CDTIPOCARD'] = $row['CDTIPOCARD'];

        try {
            if ($tipoReceita === 'S') {
                $filial = $row['CDFILIAL'];
                $servico = $row['CDSERVFILI'];
                
                $receita = $this->receitaController->returnRecipeServico($cdprato, $cdFilAuxPrat, $filial, $servico);
                isset($receita['IDQTDEFIXSE']) ? $qtAtiva = $receita['IDQTDEFIXSE'] : $qtAtiva = null;
                if ($receita){
                    foreach ($receita as $produtos) {
                        if ($produtos['CDPRODUTO'] <> $produto) {
                            $isValidUnit = $this->isValidUnitConv($produtos['CDPRODUTO'], $sgUnidadePrato, $produtos['SGUNIDADE']);
                            $isChangeQt = $is_adjust_person_qt ? $isValidUnit : $produtos['IDQTDEFIXSE'] <> 'S';
                            if ($isChangeQt) {
                                $quantidadesAtualizadas = $this->calcAlteracaoProporcional(
                                    $qtAtiva,
                                    $produtos['QTPRODRECSER'],
                                    $produtos['QTBRUTASEUNR'],
                                    $produtos['QTBRUTASE'],
                                    ($produtos['VRPEFATCOCSE'] + 100),
                                    (100 - $produtos['VRPEFATCORSE']),
                                    $produtos['QTCALCNUTRSE'],
                                    $percentual,
                                    $tpOperacao
                                );
                                $produtos['QTPRODRECSER'] = $quantidadesAtualizadas['QTLIQUIDA'];
                                $produtos['QTBRUTASEUNR'] = $quantidadesAtualizadas['QTBRUTA'];
                                $produtos['QTBRUTASE']    = $quantidadesAtualizadas['QTDREQUERIDA'];
                                $produtos['QTCALCNUTRSE'] = $quantidadesAtualizadas['QTNUTRICIONAL'];
                                $produtos['__is_new'] = false;
                                
                                $this->receitaController->insertRecipeService($produtos);
                            }
                        }
                    }
                }
            }
            else if ($tipoReceita === 'L') {
                $filial = $row['CDFILIAL'];
                $receita = $this->receitaController->returnRecipeLocal($cdprato, $cdFilAuxPrat, $filial);
                isset($receita['IDQTDEFIXLO']) ? $qtAtiva = $receita['IDQTDEFIXLO'] : $qtAtiva = null;
                if ($receita){
                    foreach ($receita as $produtos) {
                        if ($produtos['CDPRODUTO'] <> $produto) {
                            $isValidUnit = $this->isValidUnitConv($produtos['CDPRODUTO'], $sgUnidadePrato, $produtos['SGUNIDADE']);
                            $isChangeQt = $is_adjust_person_qt ? $isValidUnit : $produtos['IDQTDEFIXLO'] <> 'S';
                            if ($isChangeQt) {
                                $quantidadesAtualizadas = $this->calcAlteracaoProporcional(
                                    $qtAtiva,
                                    $produtos['QTPRODRECLOC'],
                                    $produtos['QTBRUTALOUNR'],
                                    $produtos['QTBRUTALO'],
                                    ($produtos['VRPEFATCOCLO'] + 100),
                                    (100 - $produtos['VRPEFATCORLO']),
                                    $produtos['QTCALCNUTRLO'],
                                    $percentual, $tpOperacao
                                );
    
                                $produtos['QTPRODRECLOC'] = $quantidadesAtualizadas['QTLIQUIDA'];
                                $produtos['QTBRUTALOUNR'] = $quantidadesAtualizadas['QTBRUTA'];
                                $produtos['QTBRUTALO']    = $quantidadesAtualizadas['QTDREQUERIDA'];
                                $produtos['QTCALCNUTRLO'] = $quantidadesAtualizadas['QTNUTRICIONAL'];
                                $produtos['__is_new'] = false;
                                
                                $this->receitaController->insertRecipeLocal($produtos);
                            }
                        }
                    }
                }
            }
            else if ($tipoReceita === 'P'){
                $receita = $this->receitaController->returnRecipePadrao($cdprato, $cdFilAuxPrat);
                isset($receita['IDQTDEFIXPR']) ? $qtAtiva = $receita['IDQTDEFIXPR'] : $qtAtiva = null;
                if ($receita) {
                    foreach ($receita as $produtos) {
                        if ($produtos['CDPRODUTO'] <> $produto) {
                            $isValidUnit = $this->isValidUnitConv($produtos['CDPRODUTO'], $sgUnidadePrato, $produtos['SGUNIDADE']);
                            $isChangeQt = $is_adjust_person_qt ? $isValidUnit : $produtos['IDQTDEFIXPR'] <> 'S';
                            if ($isChangeQt) {
                                $quantidadesAtualizadas = $this->calcAlteracaoProporcional(
                                    $qtAtiva,
                                    $produtos['QTPRODPRAT'],
                                    $produtos['QTBRUTAPRUNR'],
                                    $produtos['QTBRUTAPR'],
                                    ($produtos['VRPEFATCOCPR'] + 100),
                                    (100 - $produtos['VRPEFATCORPR']),
                                    $produtos['QTCALCNUTRPR'],
                                    $percentual,
                                    $tpOperacao);
                                    
                                $produtos['QTPRODPRAT']   = $quantidadesAtualizadas['QTLIQUIDA'];
                                $produtos['QTBRUTAPRUNR'] = $quantidadesAtualizadas['QTBRUTA'];
                                $produtos['QTBRUTAPR']    = $quantidadesAtualizadas['QTDREQUERIDA'];
                                $produtos['QTCALCNUTRPR'] = $quantidadesAtualizadas['QTNUTRICIONAL'];
                                $produtos['__is_new'] = false;
                                $this->receitaController->insertRecipeStandard($produtos);
                            }
                        }
                    }
                }
            }
            else if ($tipoReceita === 'C') {
                $cardapio = $row['CDTIPOCARD'];
                $receita = $this->receitaController->returnRecipeTpCard($cdprato, $cdFilAuxPrat, $cardapio, $cdfilcentpme);
                isset($receita['IDQTDEFIXPRTP']) ? $qtAtiva = $receita['IDQTDEFIXPRTP'] : $qtAtiva = null;
                if ($receita) {
                    foreach ($receita as $produtos) {
                        if ($produtos['CDPRODUTO'] <> $produto) {
                            $isValidUnit = $this->isValidUnitConv($produtos['CDPRODUTO'], $sgUnidadePrato, $produtos['SGUNIDADE']);
                            $isChangeQt = $is_adjust_person_qt ? $isValidUnit : $produtos['IDQTDEFIXPRTP'] <> 'S';
                            if ($isChangeQt) {
                                $quantidadesAtualizadas = $this->calcAlteracaoProporcional(
                                    $qtAtiva,
                                    $produtos['QTPRODPRATTP'],
                                    $produtos['QTBRUTAPRUNRTP'],
                                    $produtos['QTBRUTAPRTP'],
                                    ($produtos['VRPEFATCOCPRTP'] + 100),
                                    (100 - $produtos['VRPEFATCORPRTP']),
                                    $produtos['QTCALCNUTRPRTP'],
                                    $percentual,
                                    $tpOperacao
                                );
                                $produtos['QTPRODPRATTP'] = $quantidadesAtualizadas['QTLIQUIDA'];
                                $produtos['QTBRUTAPRUNRTP'] = $quantidadesAtualizadas['QTBRUTA'];
                                $produtos['QTBRUTAPRTP']    = $quantidadesAtualizadas['QTDREQUERIDA'];
                                $produtos['QTCALCNUTRPRTP'] = $quantidadesAtualizadas['QTNUTRICIONAL'];
                                $produtos['__is_new'] = false;

                                $this->receitaController->insertRecipeTpCard($produtos);
                            }
                        }
                    }
                }
            }
            $response->addDataSet(new DataSet("success", array(true)));
        } catch (\Exception $e) {
            $this->connection->rollback();
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    private function isValidUnitConv($produto, $sgUnidadePrato, $sgUnidadeProd){
        $isEqual = $sgUnidadePrato == $sgUnidadeProd;
        if($isEqual) return true;
        $result = $this->retornaFatorConversaoPrato($produto, $sgUnidadePrato, $sgUnidadeProd);
        return !empty($result);
    }
    
    public function retornaFatorConversaoPrato($produto, $sgunidade, $sgunidadeCompar){
        $sql = "SELECT TO_NUMBER(C.VRFATOCONVES) AS VRFATOCONVES,
                        RPAD('/', 1, ' ')       AS IDTIPOPE,
                        0 AS ORDEM
                   FROM CONVPRODUTO C
                   LEFT JOIN PRODUTO P ON P.CDPRODUTO = C.CDPRODUTO
                  WHERE (C.CDPRODUTO = :P_CDPRODUTO)
                    AND (P.SGUNIDADE = :P_SGUNIDADEORI)
                    AND (C.SGUNIDADE = :P_SGUNIDADEDEST)

                  UNION ALL

                 SELECT TO_NUMBER(C.VRFATOCONVES) AS VRFATOCONVES,
                        RPAD('*', 1, ' ')       AS IDTIPOPE,
                        1 AS ORDEM
                   FROM CONVPRODUTO C
                   LEFT JOIN PRODUTO P ON P.CDPRODUTO = C.CDPRODUTO
                  WHERE (C.CDPRODUTO = :P_CDPRODUTO)
                    AND (P.SGUNIDADE = :P_SGUNIDADEDEST)
                    AND (C.SGUNIDADE = :P_SGUNIDADEORI)

                  UNION ALL

                 SELECT TO_NUMBER(VRFTCONVER)  AS VRFATOCONVES,
                        RPAD(IDTIPOPE, 1, ' ') AS IDTIPOPE,
                        2 AS ORDEM
                   FROM CONVUNID
                  WHERE (SGUNIDPARA = :P_SGUNIDADEDEST)
                    AND (SGUNIDDE = :P_SGUNIDADEORI)

                  UNION ALL

                 SELECT TO_NUMBER(VRFTCONVER)  AS VRFATOCONVES,
                        RPAD(IDTIPOPE, 1, ' ') AS IDTIPOPE,
                        3 AS ORDEM
                   FROM CONVUNID
                  WHERE (SGUNIDPARA = :P_SGUNIDADEORI )
                    AND (SGUNIDDE = :P_SGUNIDADEDEST )

                  ORDER BY ORDEM";

        $params = array(
            "P_CDPRODUTO" => $produto,
            "P_SGUNIDADEORI" => $sgunidade,
            "P_SGUNIDADEDEST" => $sgunidadeCompar
        );

        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
	
	protected function calcAlteracaoProporcional($campoAtivo, $qtdeLiq, $qtdeBruta, $qtdeReq, $aprovCoc, $aprovLimp, $qtdeNutr, $proporcaoQuantidade, $tpOperacao = 'M'){
        if ($tpOperacao === 'M') { // em caso de multiplicacao
            $quantidadeReq = $qtdeReq * floatval($proporcaoQuantidade);
            $quantidadeNut = $qtdeNutr * floatval($proporcaoQuantidade);
            $quantidadeLiq = $qtdeLiq * floatval($proporcaoQuantidade);
            $quantidadeBru = $qtdeBruta * floatval($proporcaoQuantidade);
        } else { // em caso de divisão
            $quantidadeReq = $qtdeReq / floatval($proporcaoQuantidade);
            $quantidadeNut = $qtdeNutr / floatval($proporcaoQuantidade);

            $quantidadeLiq = $qtdeLiq / floatval($proporcaoQuantidade);
            $quantidadeBru = $qtdeBruta / floatval($proporcaoQuantidade);
        }

        $return = array(
            'QTDREQUERIDA'  => $quantidadeReq,
            'QTNUTRICIONAL' => $quantidadeNut,
            'QTLIQUIDA'     => $quantidadeLiq,
            'QTBRUTA'       => $quantidadeBru
        );
        return $return;
    }
    
    public function retornaServicosInd(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $conditions = '';
            $inner = '';
            $paramsFilial = array();
            $paramsGrupServ = array();
            $paramsGrupFili = array();
            $paramIdTIpoServ = array();
            $paramsCentral = array();

            if ($row['CDGRUPFILI'] !== 'T') {        
                $inner = " INNER JOIN FILGRUPFILI F ON ( FI.CDFILIAL = F.CDFILIAL ) AND F.CDGRUPFILI = :CDGRUPFILI ";
                $paramsGrupFili = array(
                  "CDGRUPFILI" => $row['CDGRUPFILI']
                ); 
                
                /* $conditions .= ' AND ((INSTR(:CDGRUPFILI, F.CDGRUPFILI) <> 0)) ';
                $paramsGrupFili = array(
                  "CDGRUPFILI" => $row['CDGRUPFILI']
                ); */
            }
           
            if ($row['CDFILIAL'] != 'T') {         
                $conditions .= 'AND ((INSTR(:CDFILIAL, S.CDFILIAL) <> 0)) ';
                $paramsFilial = array(
                  "CDFILIAL" => $row['CDFILIAL']
                );
            }
         
            if ($row['CDGRUPSERV'] != 'T') {    
                $conditions .= 'AND ((INSTR(:CDGRUPSERV, S.CDGRUPSERV) <> 0)) ';
                $paramsGrupServ = array(
                  "CDGRUPSERV" => $row['CDGRUPSERV']
                );
            }
           
            if (isset($row['IDTIPOSERV']) == true) {
                if ($row['IDTIPOSERV'] == '') {
                    $row['IDTIPOSERV'] = '';
                    
                    /* $paramsCentral = array("P_CDFILCENTPME" => $row['CDFILCENTPME']);
                    $conditions .= ' AND FI.CDFILCENTPME = :P_CDFILCENTPME '; */
                } else {
                    $conditions .= ' AND (IDTIPOSERV = :IDTIPOSERV)';
                    $paramIdTIpoServ = array(
                      "IDTIPOSERV" => $row['IDTIPOSERV']
                    );
                }
            }

            $sql = "SELECT DISTINCT S.CDGRUPSERV, S.CDFILIAL, SUBSTR(FI.NMFILIAL, 1, 20) NMFILIAL, 
                           S.CDSERVFILI, S.NMSERVICO, ( S.CDFILIAL || S.CDSERVFILI ) AS FILISERV, 
                           S.NRORG 
                      FROM SERVICO     S, FILIAL      FI ". $inner." 
                      WHERE ( FI.CDFILIAL = S.CDFILIAL ) ". 
                        $conditions." ORDER BY S.CDFILIAL, S.CDSERVFILI";

            $params = array_merge($paramsCentral, $paramsFilial, $paramsGrupFili, $paramsGrupServ, $paramIdTIpoServ);

            $stmt = $this->connection->prepare($sql);
            $stmt->execute($params);
            $result = $stmt->fetchAll();
            $response->addDataSet(new DataSet("result", $result));
        } catch (\Exception $e) {
	    	$response->setError(new Error($e->getMessage(), 500)); 
		}
    }
}