<?php
/**
 * Geral\Repositories
 *
 * @category Php
 * @package  Geral\Repositories
 * @author
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
namespace Geral\Repositories;

/**
 * Class Organizacao
 *
 * @category Php
 * @package  Geral\Repositories
 * @author
 * @license  www.teknisa.com Teknisa
 * @link     http://localhost:9090/tecfood
 */
class Organizacao extends \Doctrine\ORM\EntityRepository
{
    /**
     * @return bool|mixed
     */
    public function retornaMaxOrganizacao()
    {
        $sqlMax = "SELECT MAX(NRORG)+1 FROM ORGANIZACAO";

        $result = $this->getEntityManager()->getConnection()->fetchColumn($sqlMax);
        return ($result) ? $result : false;
    }

    public function obtemTodasOrganizacoes($filters){

        $filterString = "WHERE 1 = 1";
        foreach($filters as $filter){
            if($filter["value"]) {
                if($filter["value"] == "O"){
                    $filterString .= " AND " . $filter["columnName"] . " <> 'F' AND " . $filter["columnName"] . " <> 'J' "  ;
                }elseif ($filter["operator"] == 'LIKE'){
                    $filterString .= " AND UPPER(" . $filter["columnName"] . ") " . $filter["operator"] . " UPPER('%" . $filter["value"] . "%')";
                }else{
                    $filterString .= " AND " . $filter["columnName"] . " " . $filter["operator"] . " '" . $filter["value"] . "'";
                }
             }
        }
        $query = "
        SELECT  NRORG, NMRAZSOCIALORG, NMORGANIZACAO,
                CASE PREPSTATUS
                WHEN 'C' THEN 'Gerar estrutura'
                WHEN 'S' THEN 'Solicitado'
                WHEN 'Q' THEN 'Gerar dados iniciais'
                WHEN 'P' THEN 'Ativa'
                END AS ORGSTATUS
        FROM ORGANIZACAO
        $filterString";
        $result = $this->getEntityManager()->getConnection()->fetchAll($query);
        return ($result) ? $result : false;
    }

    public function obtemPorId($id){
        $query = "
        SELECT    O.NRINSCRICAOORG, O.IDTIPOINSCRORG, O.NMRAZSOCIALORG, O.NMORGANIZACAO,
                  O.NRORG, O.IDATIVO, O.NMACESSO, O.CDPAIS, O.SGESTADO,
                  O.CDMUNICIPIO, O.NMBAIREMPR AS SA_BAIRRO, O.NRCEPEMPR, O.NRINSJUREMPR,
                  O.NRINSCESTA, O.DSLOGRADEMPR, O.NRLOGRADEMPR, O.DSCMPLOGEMPR,
                  O.CDINSCMUNI, O.DSEMAILEMPRESA, O.NRTELEFOEMPR, O.NMOPERADOR,
                  O.DSEMAILOPER, SP.NMPAIS AS SA_PAIS, SE.NMESTADO AS SA_ESTADO, O.PREPSTATUS,
                  O.DTULTATU,
                  CASE O.IDTIPOINSCRORG
                    WHEN 'J' THEN 'Pessoa Jurídica'
                    WHEN 'F' THEN 'Pessoa Física'
                    ELSE 'Outro'
                  END AS TIPOORG,
                  SM.NMMUNICIPIO AS SA_MUNICIPIO,
                  CASE
                    WHEN SEMP.NRORG IS NULL THEN 'N'
                    ELSE 'S'
                  END AS ESTA_PREPARADA
        FROM      ORGANIZACAO O
        LEFT JOIN SA_PAIS SP ON (O.CDPAIS = SP.CDPAIS)
        LEFT JOIN SA_ESTADO SE ON (O.SGESTADO = SE.SGESTADO)
        LEFT JOIN SA_MUNICIPIO SM ON (O.CDMUNICIPIO = SM.CDMUNICIPIO AND O.SGESTADO = SM.SGESTADO)
        LEFT JOIN SA_EMPRESA SEMP ON (O.NRORG = SEMP.NRORG)
        WHERE     O.NRORG = :id
        ";
        $param = array("id" => $id);
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $param);
        return ($result) ? $result : false;
    }

    public function maxNrinscricaoorg()
    {
        $sqlMax = "SELECT MAX(TO_NUMBER(NRINSCRICAOORG))+1 FROM ORGANIZACAO";
        $result = $this->getEntityManager()->getConnection()->fetchColumn($sqlMax);
        return ($result) ? $result : false;
    }

    public function executaQueryParaPrepararEstrutura($query){
        $resultado = $this->getEntityManager()->getConnection()->executeQuery($query);
        return $query;
    }

}
